/*
** $VER: ImageBackFill.h 1.13 (19.3.95)
**
** Tests backfill hooks in screens
**
** (W) 1992-95 by Pierre Carrette & Walter Drwald
*/

#include <intuition/screens.h>
#include <datatypes/pictureclass.h>
#include <datatypes/pictureclassext.h>
#include <clib/macros.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <proto/intuition.h>
#include <proto/graphics.h>
#include <proto/datatypes.h>
#include <string.h>

struct BackFillOptions
{
	WORD MaxCopyWidth;  //2 maximum width for the copy
	WORD MaxCopyHeight; //2 maximum height for the copy
	BOOL CenterX;       //2 center the tiles horizontally?
	BOOL CenterY;       //2 center the tiles vertically?
	WORD OffsetX;       //2 offset to add
	WORD OffsetY;       //2 offset to add
	BOOL OffsetTitleY;  //2 add the screen titlebar height to the vertical offset?
}; //14 

struct BackFillInfo
{
	struct Hook            Hook; //20
	struct Screen         *Screen; //4
	Object                *PictureObject; //4
	struct BitMapHeader   *BitMapHeader; //4
	struct BitMap         *BitMap; //4
	WORD                   CopyWidth; //2
	WORD                   CopyHeight; //2
	struct BackFillOptions Options; //14
}; //54

BOOL LoadBackgroundImage(struct BackFillInfo *BFI,STRPTR PicName,struct Screen *Scr,struct BackFillOptions *BFO);
void UnloadBackgroundImage(struct BackFillInfo *BFI);
